# Ipopt::MumpsSolverInterface Class Reference

Interface to the linear solver Mumps, derived from SparseSymLinearSolverInterface. More...

`#include <IpMumpsSolverInterface.hpp>`

Inheritance diagram for Ipopt::MumpsSolverInterface:
[legend]

List of all members.

## Public Member Functions
bool | InitializeImpl (const OptionsList &options, const std::string &prefix)
| overloaded from AlgorithmStrategyObject
virtual bool | ProvidesDegeneracyDetection () const
| Query whether the indices of linearly dependent rows/columns can be determined by this linear solver.
virtual ESymSolverStatus | DetermineDependentRows (const Index *ia, const Index *ja, std::list< Index > &c_deps)
| This method determines the list of row indices of the linearly dependent rows.
Constructor/Destructor
| MumpsSolverInterface ()
| Constructor.
virtual | ~MumpsSolverInterface ()
| Destructor.
Methods for requesting solution of the linear system.
virtual ESymSolverStatus | InitializeStructure (Index dim, Index nonzeros, const Index *airn, const Index *ajcn)
| Method for initializing internal stuctures.
virtual double * | GetValuesArrayPtr ()
| Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.
virtual ESymSolverStatus | MultiSolve (bool new_matrix, const Index *airn, const Index *ajcn, Index nrhs, double *rhs_vals, bool check_NegEVals, Index numberOfNegEVals)
| Solve operation for multiple right hand sides.
virtual Index | NumberOfNegEVals () const
| Number of negative eigenvalues detected during last factorization.
## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| MumpsSolverInterface (const MumpsSolverInterface &)
| Copy Constructor.
void | operator= (const MumpsSolverInterface &)
| Overloaded Equals Operator.
Internal functions
ESymSolverStatus | SymbolicFactorization ()
| Call MUMPS (job=1) to perform symbolic manipulations, and reserve memory.
ESymSolverStatus | Factorization (bool check_NegEVals, Index numberOfNegEVals)
| Call MUMPS (job=2) to factorize the Matrix.
ESymSolverStatus | Solve (Index nrhs, double *rhs_vals)
| Call MUMPS (job=3) to do the solve.
## Private Attributes
bool | have_symbolic_factorization_
| Flag indicating if symbolic factorization has already been called.
Information about the matrix
void * | mumps_ptr_
| Primary MUMP data structure.
Information about most recent factorization/solve
Index | negevals_
| Number of negative eigenvalues.
Solver specific data/options
Number | pivtol_
| Pivol tolerance.
Number | pivtolmax_
| Maximal pivot tolerance.
Index | mem_percent_
| Percent increase in memory.
Index | mumps_permuting_scaling_
| Permution and scaling method in MUMPS.
Index | mumps_pivot_order_
| Pivot order in MUMPS.
Index | mumps_scaling_
| Scaling in MUMPS.
Number | mumps_dep_tol_
| Threshold in MUMPS to stay that a constraint is linearly dependent.
bool | warm_start_same_structure_
| Flag indicating whether the TNLP with identical structure has already been solved before.
## Initialization flags
bool | initialized_
| Flag indicating if internal data is initialized.
bool | pivtol_changed_
| Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.
bool | refactorize_
| Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.
static int | instancecount_mpi
| Counter on number of alive Mumps interface objects, if we have called MPI_Initialize.
virtual bool | IncreaseQuality ()
| Request to increase quality of solution for next solve.
virtual bool | ProvidesInertia () const
| Query whether inertia is computed by linear solver.
EMatrixFormat | MatrixFormat () const
| Query of requested matrix type that the linear solver understands.
static void | RegisterOptions (SmartPtr< RegisteredOptions > roptions)
| Methods for IpoptType.

## Detailed Description

Interface to the linear solver Mumps, derived from SparseSymLinearSolverInterface.

For details, see description of SparseSymLinearSolverInterface base class.

Definition at line 26 of file IpMumpsSolverInterface.hpp.

## Constructor & Destructor Documentation

Ipopt::MumpsSolverInterface::MumpsSolverInterface | ( |  | ) |

Constructor.

virtual Ipopt::MumpsSolverInterface::~MumpsSolverInterface | ( |  | ) | `[virtual]`

Destructor.

Ipopt::MumpsSolverInterface::MumpsSolverInterface | ( | const MumpsSolverInterface & |  | ) | `[private]`

Copy Constructor.

## Member Function Documentation

bool Ipopt::MumpsSolverInterface::InitializeImpl | ( | const OptionsList & | options,
|  | const std::string & | prefix |
| ) |  |  | `[virtual]`

overloaded from AlgorithmStrategyObject

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::MumpsSolverInterface::InitializeStructure | ( | Index | dim,
|  | Index | nonzeros,
|  | const Index * | airn,
|  | const Index * | ajcn |
| ) |  |  | `[virtual]`

Method for initializing internal stuctures.

Here, ndim gives the number of rows and columns of the matrix, nonzeros give the number of nonzero elements, and airn and acjn give the positions of the nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual double* Ipopt::MumpsSolverInterface::GetValuesArrayPtr | ( |  | ) | `[virtual]`

Method returing an internal array into which the nonzero elements (in the same order as airn and ajcn) are to be stored by the calling routine before a call to MultiSolve with a new_matrix=true.

The returned array must have space for at least nonzero elements.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::MumpsSolverInterface::MultiSolve | ( | bool | new_matrix,
|  | const Index * | airn,
|  | const Index * | ajcn,
|  | Index | nrhs,
|  | double * | rhs_vals,
|  | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[virtual]`

Solve operation for multiple right hand sides.

Overloaded from SparseSymLinearSolverInterface.

Implements Ipopt::SparseSymLinearSolverInterface.

virtual Index Ipopt::MumpsSolverInterface::NumberOfNegEVals | ( |  | ) | const`[virtual]`

Number of negative eigenvalues detected during last factorization.

Returns the number of negative eigenvalues of the most recent factorized matrix. This must not be called if the linear solver does not compute this quantities (see ProvidesInertia).

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::MumpsSolverInterface::IncreaseQuality | ( |  | ) | `[virtual]`

Request to increase quality of solution for next solve.

Ask linear solver to increase quality of solution for the next solve (e.g. increase pivot tolerance). Returns false, if this is not possible (e.g. maximal pivot tolerance already used.)

Implements Ipopt::SparseSymLinearSolverInterface.

virtual bool Ipopt::MumpsSolverInterface::ProvidesInertia | ( |  | ) | const`[inline, virtual]`

Query whether inertia is computed by linear solver.

Returns true, if linear solver provides inertia.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 92 of file IpMumpsSolverInterface.hpp.

EMatrixFormat Ipopt::MumpsSolverInterface::MatrixFormat | ( |  | ) | const`[inline, virtual]`

Query of requested matrix type that the linear solver understands.

Implements Ipopt::SparseSymLinearSolverInterface.

Definition at line 99 of file IpMumpsSolverInterface.hpp.

static void Ipopt::MumpsSolverInterface::RegisterOptions | ( | SmartPtr< RegisteredOptions > | roptions | ) | `[static]`

Methods for IpoptType.

virtual bool Ipopt::MumpsSolverInterface::ProvidesDegeneracyDetection | ( |  | ) | const`[virtual]`

Query whether the indices of linearly dependent rows/columns can be determined by this linear solver.

Reimplemented from Ipopt::SparseSymLinearSolverInterface.

virtual ESymSolverStatus Ipopt::MumpsSolverInterface::DetermineDependentRows | ( | const Index * | ia,
|  | const Index * | ja,
|  | std::list< Index > & | c_deps |
| ) |  |  | `[virtual]`

This method determines the list of row indices of the linearly dependent rows.

Reimplemented from Ipopt::SparseSymLinearSolverInterface.

void Ipopt::MumpsSolverInterface::operator= | ( | const MumpsSolverInterface & |  | ) | `[private]`

Overloaded Equals Operator.

Reimplemented from Ipopt::AlgorithmStrategyObject.

ESymSolverStatus Ipopt::MumpsSolverInterface::SymbolicFactorization | ( |  | ) | `[private]`

Call MUMPS (job=1) to perform symbolic manipulations, and reserve memory.

ESymSolverStatus Ipopt::MumpsSolverInterface::Factorization | ( | bool | check_NegEVals,
|  | Index | numberOfNegEVals |
| ) |  |  | `[private]`

Call MUMPS (job=2) to factorize the Matrix.

It is assumed that the first nonzeros_ element of a_ contain the values of the matrix to be factorized.

ESymSolverStatus Ipopt::MumpsSolverInterface::Solve | ( | Index | nrhs,
|  | double * | rhs_vals |
| ) |  |  | `[private]`

Call MUMPS (job=3) to do the solve.

## Member Data Documentation

void* Ipopt::MumpsSolverInterface::mumps_ptr_`[private]`

Primary MUMP data structure.

Definition at line 139 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::negevals_`[private]`

Number of negative eigenvalues.

Definition at line 145 of file IpMumpsSolverInterface.hpp.

bool Ipopt::MumpsSolverInterface::initialized_`[private]`

Flag indicating if internal data is initialized.

For initialization, this object needs to have seen a matrix

Definition at line 152 of file IpMumpsSolverInterface.hpp.

bool Ipopt::MumpsSolverInterface::pivtol_changed_`[private]`

Flag indicating if the matrix has to be refactorized because the pivot tolerance has been changed.

Definition at line 155 of file IpMumpsSolverInterface.hpp.

bool Ipopt::MumpsSolverInterface::refactorize_`[private]`

Flag that is true if we just requested the values of the matrix again (SYMSOLVER_CALL_AGAIN) and have to factorize again.

Definition at line 159 of file IpMumpsSolverInterface.hpp.

int Ipopt::MumpsSolverInterface::instancecount_mpi`[static, private]`

Counter on number of alive Mumps interface objects, if we have called MPI_Initialize.

When the last object is destroyed, we will call MPI_Finalize.

Definition at line 164 of file IpMumpsSolverInterface.hpp.

Number Ipopt::MumpsSolverInterface::pivtol_`[private]`

Pivol tolerance.

Definition at line 170 of file IpMumpsSolverInterface.hpp.

Number Ipopt::MumpsSolverInterface::pivtolmax_`[private]`

Maximal pivot tolerance.

Definition at line 173 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::mem_percent_`[private]`

Percent increase in memory.

Definition at line 176 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::mumps_permuting_scaling_`[private]`

Permution and scaling method in MUMPS.

Definition at line 179 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::mumps_pivot_order_`[private]`

Pivot order in MUMPS.

Definition at line 182 of file IpMumpsSolverInterface.hpp.

Index Ipopt::MumpsSolverInterface::mumps_scaling_`[private]`

Scaling in MUMPS.

Definition at line 185 of file IpMumpsSolverInterface.hpp.

Number Ipopt::MumpsSolverInterface::mumps_dep_tol_`[private]`

Threshold in MUMPS to stay that a constraint is linearly dependent.

Definition at line 189 of file IpMumpsSolverInterface.hpp.

bool Ipopt::MumpsSolverInterface::warm_start_same_structure_`[private]`

Flag indicating whether the TNLP with identical structure has already been solved before.

Definition at line 193 of file IpMumpsSolverInterface.hpp.

bool Ipopt::MumpsSolverInterface::have_symbolic_factorization_`[private]`

Flag indicating if symbolic factorization has already been called.

Definition at line 198 of file IpMumpsSolverInterface.hpp.

The documentation for this class was generated from the following file:

- src/Algorithm/LinearSolvers/IpMumpsSolverInterface.hpp

All Classes Files Functions Variables Typedefs Enumerations Enumerator Friends Defines